﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Brancher extends Sprite
	{
		private var rot:Number;
		private var theta:Number=0;
		private var stack:Array = new Array();
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		public function Brancher()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*360;
			i=0;
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			rot=-30*Math.sin(Math.PI / 180 * mouseY/1000);
			theta+=0.005;
			if(i<100){
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0xffffcc,1);
				stack[i].graphics.lineStyle(1,0xCCCC99,1);
				stack[i].graphics.drawRoundRect(0,0,100,100,20,20);
				stack[i].x = centerX+Math.cos(rot)*i*mouseX/100;
				stack[i].y = centerY-Math.sin(rot)*i*3*mouseY/100;
				stack[i].scaleX =1-i/250;
				stack[i].scaleY =1-i/250;
				addChild(stack[i]);
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,enterHandler);
			}
		}
	}
}